import java.util.stream.Stream;

public class ComputeANumber {
	
	public static long factorial(long n) {
	
		long output = 1;
		for (; n > 1; n--)
			output *= n;
		return output;
		
	}
	
	public static void main(String args[]) {
		
		/*
		Stream.iterate(0, n -> n + 1)
		      .limit(5)
		      .forEach(System.out::println);
		*/
		
		/*
		Stream<Integer> stage1 = Stream.iterate(0, n -> n + 1);
		stage1 = stage1.limit(5);
		stage1.forEach(System.out::println);
		*/
		
		/*
		Stream.iterate(0, n -> n + 1)
		      .limit(5)
		      .map(n -> factorial(n))
              .forEach(System.out::println);
        */
		
		/*
		Stream.iterate(0, n -> n + 1)
			  .limit(5)
			  .map(n -> 1.0 / factorial(n))
	          .forEach(System.out::println);
	    */
		
		// Compute the sum of inverses of factorials
		double e = Stream.iterate(0, n -> n + 1)
				         .limit(30)
			             .map(n -> 1.0 / factorial(n))
			             .reduce(0.0, (s, x) -> s + x);
		System.out.println("Euler constant = " + e);
		System.out.println("Euler constant = " + Math.E);
		
	}
}
